(in-package :cl-user)
(defpackage art.web
  (:use :cl
        :caveman2
        :art.config
        :art.view
        :art.db
        :datafly
        :sxql)
  (:export :*web*))
(in-package :art.web)

;; for @route annotation
(syntax:use-syntax :annot)

;;
;; Application

(defclass <web> (<app>) ())
(defvar *web* (make-instance '<web>))
(clear-routing-rules *web*)

;;
;; Routing rules

(defvar *questions* '(("1" . (("id" . "1")
						("ques" . "Who painted The Swing?")
						("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/the-swing-1.jpeg?resize=622%2C533&ssl=1")
						("a" . "Eugène Delacroix")
						("b" . "Augustin Meinrad Bächtiger")
						("c" . "Irene Bache")
						("d" . "Peggy Bacon")
						("answer" . "a")
						("next" . "2")
						))
						("2" . (("id" . "2")
						("ques" . "Who painted the Mona Lisa?")
						 ("image" . "https://th.bing.com/th/id/OIP.ZdwKGoUNH9JTmr7VAk9v0ADDEs?pid=ImgDet&w=620&h=950&rs=1")
						("a" . "Irene Bache")
						("b" . "Leonardo Da Vinci")
						("c" . "Vincent van Gogh")
						("d" . "Dirck van Baburen")
						("answer" . "b")
						("next" . "3")
						))
						("3" . (("id" . "3")
						("ques" . "What is the name of this painting?")
						("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/whistlers-mother-2.jpeg?resize=554%2C493&ssl=1")
					    ("a" . "Lady sitting")
						("b" . "Whistler’s Mother")
						("c" . "Lost in thoughts")
						("d" . "Loosing time")
						("answer" . "b")
						("next" . "4")
						))
						("4" . (("id" . "4")
						("ques" . "Who painted The scream?")
						("image" . "https://www.topteny.com/wp-content/uploads/2014/10/8850-Munch-The-Scream-e1337760650177.jpg?x42363")
						("a" . "Gustav Klimt")
						("b" . "Claude Monet")
						("c" . "Johanes Vermeer")
						("d" . "Edvard Munch")
						("answer" . "d")
						("next" . "5")
						))
					))


(defvar *paintings* '(("1" . (("id" . "1")
					    ("title" . "The Potato Eaters")
					    ("year" . "1885")
						("style" . "post-impression")
						("picid" . "Vincent van Gogh")
					    ("image" . "https://th.bing.com/th/id/R.4ebb66c97dd0d837141b88ab7ab54e35?rik=fU9hejRD0DbUUw&riu=http%3a%2f%2fvangoyourself.com%2fwp-content%2fuploads%2f2014%2f04%2fThe-Potato-Eaters.jpg&ehk=2O7JfuVdFZSb0GJerVAm5%2bOl0pzRGz8sq2UNnXnSQMs%3d&risl=1&pid=ImgRaw&r=0")
					    ("description" . "The Potato Eaters was a synthesis of countless studies of peasants' heads, of people absorbed in work and handicrafts, which van Gogh painted that winter in the poor cottages in the village. He had to paint a whole series of pictures in order to achieve any real closeness with these intractable people, and his approach resulted in a final triumph.")))
					("2" . (("id" . "2")
					    ("title" . "Starry Night")
					    ("year" . "1889")
						("style" . "post-impression")
						("picid" . "Vincent van Gogh")
					    ("image" . "https://images.fineartamerica.com/images/artworkimages/mediumlarge/3/the-starry-night-by-van-gogh-original-oil-reproduction-arina-yastrebova.jpg")
					    ("description" . "The Starry Night was also one of the most famous paintings of the Dutch artist Vincent Van Gogh. He created it in 1889. It is the depiction of a view of the east-facing a window of his asylum room, just before the sunrise. The painting became famous because of its modern aesthetic touch and is safeguarded in the Museum of Modern Art in New York City since 1941. Many creators have even tried making something similar too but could not achieve the success.")))
					("3" . (("id" . "3")
					    ("title" . "Mona Lisa")
					    ("year" . "1885")
						("style" . "post-impression")
						("picid" . "Leonaedo da Vinci")
					    ("image" . "https://th.bing.com/th/id/OIP.ZdwKGoUNH9JTmr7VAk9v0ADDEs?pid=ImgDet&w=620&h=950&rs=1")
					    ("description" . "The Mona Lisa is perhaps Leonardo Da Vinci’s most famous of paintings. It is an oil painting, painted on poplar wood. The painting is most famous for the smile of the woman, which people have been trying to decipher for a long time.")))
					("4" . (("id" . "4")
					    ("title" . "The Night Watch")
					    ("year" . "1642")
						("style" . "Baroque, Dutch Golden Age")
						("picid" . "Rembrandt van Rijn")
					    ("image" . "https://www.topteny.com/wp-content/uploads/2014/10/NightWatch.jpg?x42363")
					    ("description" . "The night watch is one of the best and famous paintings in the collection of the Amsterdam Museum. The Night Watch is one of the most famous Dutch Golden Age paintings made in 1642 by Rembrandt Van Rijn. This famous painting also depicts the eponymous company moving out, led by Captain Frans Banninck Cocq and his lieutenant, Willem Van Ruytenburch. The dramatic use of yellow and red shades also highlights the important characters of the famous paintings attracting our eyes towards them too.")))
					("5" . (("id" . "5")
					    ("title" . "The Scream")
					    ("year" . "1893")
						("style" . "post-impression")
						("picid" . "Edvard Munch")
					    ("image" . "https://www.topteny.com/wp-content/uploads/2014/10/8850-Munch-The-Scream-e1337760650177.jpg?x42363")
					    ("description" . "This grand old mansion sits on over 100 acres of rolling hills and dense redwood forests.")))
					("6" . (("id" . "6")
					    ("title" . "Girl with a Pearl Earring")
					    ("year" . "1885")
						("style" . "post-impression")
						("picid" . "Johannes Vermeer")
					    ("image" . "https://th.bing.com/th/id/OIP.sWfGuQQUsVAJq_kxNtPwswHaIq?pid=ImgDet&rs=1")
					    ("description" . "This wonderful painting was created by Johannes Vermeer. As the name shows, it focuses on a pearl earring. At first, it was called Girl with a Turban. In the 20th century, this name was changed. It is believed that this girl is Johannes Vermeer’s daughter. It reflects his appreciation of the role that women played in his life.")))
					("7" . (("id" . "7")
					    ("title" . "Composition 8")
					    ("year" . "1923")
						("style" . "Suprematism, Abstract art")
						("picid" . "Vasily Kandinsky")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/composition-8-2.jpeg?resize=569%2C394&ssl=1")
					    ("description" . "This geometrical sort of painting was made in 1923 by Vasily Kandinsky. It was one of the best pieces of postwar by Vasily. Kandinsky also evolved an abstract style that reflected the utopian artistic experiments of the Russian avant-garde.")))
					("8" . (("id" . "8")
					    ("title" . "Beheading of Saint John the Baptist")
					    ("year" . "1607–10")
						("style" . " Baroque")
						("picid" . "Michelangelo Merisi da Caravaggio")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/beheading-of-saint-john-the-baptist-the-famous-pai-2.jpeg?resize=555%2C385&ssl=1")
					    ("description" . "Italian artist Caravaggio made this Oil painting. This masterpiece is also considered one of the most important works in Western painting. The painting shows also different sides of death and human cruelty and how it’s scale and shadow daunt and possess humans nowadays. This painting was completed in 1608 and was celebrated worldwide by its a clear depiction of the dark world too.")))
		
					("9" . (("id" . "9")
					    ("title" . "The Persistence of Memory")
					    ("year" . "1931")
						("style" . "Surrealism")
						("picid" . "Salvador Dalí")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/the-persistence-of-memory-the-famous-painting-2.jpeg?resize=566%2C430&ssl=1")
					    ("description" . "This artwork is also one of the very famous paintings by the artist Salvador Dali completed in 1931. The painting is a depiction of Melting clocks and is one of the most recognized works. This Surreal piece of work is the representation of Dali’s theory of Softness and Hardness which is central to the thinking of the time. This modern work of art was very much appreciated by everyone and now this sits in the museum of modern art, New York City.")))
					("10" . (("id" . "10")
					    ("title" . "Luncheon on the Boating Party")
					    ("year" . "1880–1881")
						("style" . "Impressionism, Modern art")
						("picid" . "Pierre-Auguste Renoir")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/luncheon-on-the-boating-party-1.jpeg?resize=613%2C453&ssl=1")
					    ("description" . "The Luncheon on the boating party is one of the most famous paintings made in 1881 by the French painter Pierre-Auguste Renoir. This Painting was also one of the best painting in the Seventh Impressionist Exhibition in 1882. This painting is a true example of wealthiness, the beautiful impression of strokes and also an amazing art style.")))
					("11" . (("id" . "11")
					    ("title" . "Water Lilies")
					    ("year" . "1840-1926")
						("style" . "Impressionism")
						("picid" . "Claude Monet")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/the-lillies-the-famous-painting-2.jpeg?resize=515%2C428&ssl=1")
					    ("description" . "Water lilies is not just one single painting but also a series of approximately 250 oil paintings all depicting flower garden at his home in Giverny. These series is painted by French impressionist Claude Monet. All these series were also very expensive and one of them was sold for £18.5 million in an auction in London.")))
					("12" . (("id" . "12")
					    ("title" . "Las Meninas")
					    ("year" . "1656")
						("style" . "Baroque")
						("picid" . "Diego Velázquez")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/las-meninas-the-famous-painting-4.jpeg?resize=482%2C555&ssl=1")
					    ("description" . "The Las Meninas was also made by the leading Spanish artist of Golden age in 1956 by Diego Velazquez in the Madrid city. This painting is considered as one of the best and most important paintings of modern art history depicting different stories and angles in the picture also. Also, every viewer of this picture interprets a different story of the pictures due to the involvement of many subjects in the painting.")))
					("13" . (("id" . "13")
					    ("title" . "A Sunday Afternoon on the Island of La Grande Jatte")
					    ("year" . "1884–1886")
						("style" . "Pointillism, Neo-impressionism")
						("picid" . "Georges Seurat")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/a-sunday-afternoon-on-the-island-of-la-grande-jatt-2.jpeg?resize=596%2C397&ssl=1")
					    ("description" . "The “A Sunday Afternoon on the Island of La Grande Jatte” is one of the most famous paintings of George Seurat made in 1884. This painting depicts a lot of Parisians chilling on a Sunday afternoon on the banks of the River Seine. This painting was also made on a large canvas using the pointillist technique.")))
					("14" . (("id" . "14")
					    ("title" . "The Tower of Babel")
					    ("year" . "1563")
						("style" . "Dutch and Flemish Renaissance")
						("picid" . "Pieter Bruegel the Elder")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/the-tower-of-babel-1.jpeg?resize=546%2C400&ssl=1")
					    ("description" . "The tower of Babel was made in the year 1563 by Pieter Bruegel the Elder. This famous painting is one of the best depictions of religious art, also in accordance with the book of Genesis in the Bible. Mythologically, it is the origin of why people of the world speak different languages.")))
					("15" . (("id" . "15")
					    ("title" . "The Swing")
					    ("year" . "1830")
						("style" . "Rococo")
						("picid" . "Eugène Delacroix")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/the-swing-1.jpeg?resize=622%2C533&ssl=1")
					    ("description" . "The Swing is an 18th-century oil painting made by Jean-Honoré Fragonard in the Wallace Collection in London. The painting portrays a young beautiful woman sitting on a swing amidst the greenery smiling. The painting is also considered to be one of the most beautiful art pieces of all times.")))
					("16" . (("id" . "16")
					    ("title" . "The Kiss")
					    ("year" . "1907–1908")
						("style" . "Art Nouveau, Symbolism, Modern art, Vienna Secession")
						("picid" . "Gustav Klimt")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/the-kiss-2.jpeg?resize=574%2C576&ssl=1")
					    ("description" . "This perfect depiction of early modern art was made by the Austrian Painter Gustav Klimt between 1907 and 1908. This painting is also a beautiful depiction of the chemistry of a couple tangled in the silver and gold sheet and embracing each other by making love and kissing. It is one of the most popular Klimt’s work.")))
					("17" . (("id" . "17")
					    ("title" . "Whistler’s Mother")
					    ("year" . "1871")
						("style" . "Realism")
						("picid" . "James Abbott McNeill Whistler")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/whistlers-mother-2.jpeg?resize=554%2C493&ssl=1")
					    ("description" . "The Whistler’s Mother is a renowned painting made by the American born Painter Jame McNeill Whistler in 1871. The picture is of James’s Mother Anna McNeill Whistler displayed in also McNeill’s own designed frame. This is one of the most famous paintings made outside of America. This painting is known as the American Icon and also as the Victorian Mona Lisa.")))
					("18" . (("id" . "18")
					    ("title" . "Bal du Moulin de la Galette")
					    ("year" . " 1876")
						("style" . "Impressionism")
						("picid" . "Pierre-Auguste Renoir")
					    ("image" . "https://i0.wp.com/bookmypainting.com/wp-content/uploads/2019/06/bal-du-moulin-de-la-galette-2.jpeg?resize=549%2C408&ssl=1")
					    ("description" . "Current Status: At Musée d’Orsay
The Bal du Moulin de la Galette was also painted by a French artist Pierre-Auguste Renoir in 1876. This painting is also kept in Musee d’Orsay in Paris and is one of the most celebrated masterpieces. This picture is a real-life depiction of richness where working-class Persians used to gather together and celebrate with music, dance and beautiful dresses back in the 1870s.")))
					("19" . (("id" . "19")
					    ("title" . "")
					    ("year" . "")
						("style" . "")
						("picid" . "")
					    ("image" . "")
					    ("description" . "")))
					))

(defvar x 0)

(defun rightanswer (a q)
	(if (string= q a)
   (setq x (+ x 1)))
)


(defun setxzero()
	(setq x 0)
)

(defroute "/" ()
  (render #P"index.html" (list :paintings (mapcar #'(lambda (r) (cdr r)) *paintings*))))

(defroute "/about" ()
  (render #P"about.html"))

(defroute "/paintings/:id" (&key id)
  (format t "~a~%" id)
  (render #P"paintings.html" (list
			    :painting (cdr (assoc id *paintings* :test #'string=))))
			     )

(defun filter-paintings (query)
  (remove-if #'(lambda (r)
	      (let ((title (cdr (assoc "title" (cdr r) :test #'string()=))))
		(if (search query title :test #'char-equal)
		    nil
		    t
		    ))) *paintings* ))

(defroute ("/search" :method :POST) (&key _parsed)
  (format t "~a~%" (cdr (assoc "search" _parsed :test #'string=)))
  (let ((query (cdr (assoc "search" _parsed :test #'string=))))
    (render #P"lista.html"
	    (list :paintings
		  (mapcar #'(lambda (r)
			      (cdr r)) (filter-paintings query))))))


(defroute ("/quiz/:id" ) (&key id  _parsed)
  (format t "~a~%" id)
  (let ((answers (cdr (assoc "answers" _parsed :test #'string=)))
 	 (answer (cdr (assoc "answer" _parsed :test #'string=))))
	  (if (string= id "1")
	  (setxzero))
  (if (string= id "5")
  (render #P"rezult.html" (list :x x))
  (render #P"quiz.html" (list
			    :question (cdr (assoc id *questions* :test #'string=))
				:x (rightanswer answers answer )))
			     ))
)


;;
;; Error pages

(defmethod on-exception ((app <web>) (code (eql 404)))
  (declare (ignore app))
  (merge-pathnames #P"_errors/404.html"
                   *template-directory*))
